import 'package:flutter/material.dart';

import 'entry_stub.dart' if (dart.library.io) 'impl/entry_stub.impl.dart';

/// Created by taohid on 15,May, 2020
/// Email: taohid32@gmail.com

abstract class AgoraRtcWrapper {
  factory AgoraRtcWrapper(
    String appId, {
    OnError onError,
    OnJoinSuccess onJoinSuccess,
    VoidCallback onLeaveChannel,
    OnUserJoined onUserJoined,
    OnUserOffline onUserOffline,
    OnFirstRemoteVideoFrame onFirstRemoteVideoFrame,
  }) =>
      createWrapper(
        appId,
        onError: onError,
        onJoinSuccess: onJoinSuccess,
        onLeaveChannel: onLeaveChannel,
        onUserJoined: onUserJoined,
        onUserOffline: onUserOffline,
        onFirstRemoteVideoFrame: onFirstRemoteVideoFrame,
      );

  List<int> getUsers();

  void joinChannel(String channelName);

  void enableLog();

  Widget get getSelfVideoView;

  Widget getVideoView(int uid);

  void muteAudio(bool mute);

  void switchCamera();

  Widget getDefaultController({
    @required VoidCallback onCallEnd,
    @required ValueChanged<bool> onMute,
    Color selectedButtonColor,
  });

  void dispose();
}

typedef OnError = void Function(
  dynamic code,
);

typedef OnJoinSuccess = void Function(
  String channel,
  int uid,
  int elapsed,
);

typedef OnUserJoined = void Function(
  int uid,
  int elapsed,
);

typedef OnUserOffline = void Function(
  int uid,
  int reason,
);

typedef OnFirstRemoteVideoFrame = void Function(
  int uid,
  int width,
  int height,
  int elapsed,
);
